// PartBrowserDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GMEApp.h"
#include "GuiMeta.h"
#include "GMEDoc.h"
#include "GMEView.h"
#include "PartBrowserDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPartBrowserDlg dialog


CPartBrowserDlg::CPartBrowserDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPartBrowserDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPartBrowserDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	guiMetaModel = 0;
	backgroundColor = ::GetSysColor(COLOR_APPWORKSPACE);
}


void CPartBrowserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPartBrowserDlg)
	DDX_Control(pDX, IDC_ASPECT_TAB, tab);
	//}}AFX_DATA_MAP
}

void CPartBrowserDlg::Resize()
{
	RECT r;
	GetClientRect(&r);
	if(::IsWindow(tab.m_hWnd))
		tab.MoveWindow(&r);
	if(::IsWindow(partFrame.m_hWnd)) {
		tab.AdjustRect(FALSE,&r);
		r.bottom -= 2;
		r.top += 2;
		r.left += 2;
		r.right -= 2;
		partFrame.Resize(r);
	}
}

void CPartBrowserDlg::SetMetaModel(CGuiMetaModel *meta)
{
	guiMetaModel = meta;
	partFrame.pane.guiMetaModel = meta;
	partFrame.pane.parts = guiMetaModel ? &(guiMetaModel->GetParts()) : NULL;
	SetTabs();
}

void CPartBrowserDlg::SetBgColor(COLORREF bgColor)
{
	backgroundColor = bgColor;
	partFrame.pane.backgroundColor = bgColor;
}

void CPartBrowserDlg::SetTabs()
{
	tab.DeleteAllItems();
	if(guiMetaModel) {
		TC_ITEM tcItem;
		POSITION pos = 	guiMetaModel->aspects.GetHeadPosition();
		for(int ind = 0; pos; ind++) {
			CGuiMetaAspect *asp = guiMetaModel->aspects.GetNext(pos);
			tcItem.mask = TCIF_TEXT;
			char tmp[128];
			sprintf(tmp,"%s",asp->displayedName);
			tcItem.pszText = tmp;
			tcItem.cchTextMax = strlen(tcItem.pszText);
			tab.InsertItem(ind,&tcItem);
		}
	}
	Resize();
}

void CPartBrowserDlg::ChangeAspect(int ind)
{
	tab.SetCurSel(ind);
	partFrame.pane.ChangeAspect(ind);
	Resize();
}

BEGIN_MESSAGE_MAP(CPartBrowserDlg, CDialog)
	//{{AFX_MSG_MAP(CPartBrowserDlg)
	ON_WM_SIZE()
	ON_NOTIFY(TCN_SELCHANGE, IDC_ASPECT_TAB, OnSelchangeAspectTab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPartBrowserDlg message handlers

BOOL CPartBrowserDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	tab.SetWindowPos(&wndBottom,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE);
	partFrame.Create(IDD_PARTBROWSERFRAME_DIALOG,this);

	SetTabs();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPartBrowserDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	Resize();	
}

void CPartBrowserDlg::OnOK()
{
	// do nothing to avoid getting kick out
}

void CPartBrowserDlg::OnCancel()
{
	// do nothing to avoid getting kick out
}

void CPartBrowserDlg::OnSelchangeAspectTab(NMHDR* /*pNMHDR*/, LRESULT* pResult) 
{
	int s =	tab.GetCurSel();

	VERIFY(CGMEDoc::theInstance);
	CGMEDoc::theInstance->ChangeAspects(CGMEView::GetActiveView()->GetAspectName(s));
	partFrame.pane.ChangeAspect(s);
	Resize();
	*pResult = 0;
}
